abuild 8.94 KB
Newer Older
Natanael Copa's avatar
Natanael Copa committed
1 2 3 4 5 6 7 8 9 10
#!/bin/sh

# script to build apk packages (light version og makepkg)
# Copyright (c) 2008 Natanael Copa <natanael.copa@gmail.com>
#
# Distributed under GPL-2
#
# Depends on: busybox utilities, fakeroot, 
#

Natanael Copa's avatar
Natanael Copa committed
11
myver=0.4
Natanael Copa's avatar
Natanael Copa committed
12 13 14 15 16 17 18 19 20 21 22 23 24 25

# read config
MAKEAPK_CONF=${MAKEAPK_CONF:-/etc/abuild.conf}
[ -f "$MAKEAPK_CONF" ] && . "$MAKEAPK_CONF"

startdir="$PWD"
srcdir=${srcdir:-"$startdir/src"}
pkgdir=${pkgdir:-"$startdir/pkg"}
pkgrel=0

# defaults
SRCDEST=${SRCDEST:-$startdir}
PKGDEST=${PKGDEST:-$startdir}

Natanael Copa's avatar
Natanael Copa committed
26
default_cmds="sanitycheck makedepcheck clean fetch md5check unpack rootpkg"
Natanael Copa's avatar
Natanael Copa committed
27 28 29
all_cmds="checksum fetch unpack rootpkg build package cleancache clean srcpkg"

# functions
Natanael Copa's avatar
Natanael Copa committed
30
msg() {
Natanael Copa's avatar
Natanael Copa committed
31
	local sub=
32 33
	[ -n "$subpkgname" ] && sub="(sub)"
	[ -z "$quiet" ] && echo ">>> ${subpkgname:-$pkgname} $sub:" "$@" >&2
Natanael Copa's avatar
Natanael Copa committed
34 35 36 37 38 39 40 41
}

warning() {
	echo ">>> Warning:" "$@" >&2
}

die() {
	quiet=
Natanael Copa's avatar
Natanael Copa committed
42
	msg "$@" >&2
Natanael Copa's avatar
Natanael Copa committed
43 44 45
	exit 1
}

46 47 48 49 50
# check if apkbuild is basicly sane
sanitycheck() {
	[ -z "$pkgname" ] && die "Missing pkgname in APKBUILD"
	[ -z "${pkgname##* *}" ] && die "pkgname contains spaces"
	[ -z "$pkgver" ] && die "Missing pkgver in APKBUILD"
Natanael Copa's avatar
Natanael Copa committed
51
	[  "${pkgver##[0-9]}" == "$pkgver" ] && \
52 53 54 55 56 57
		die "pkgver does not start with a digit"
	[ -z "$pkgrel" ] && warning "Missing pkgrel in APKBUILD. Using pkgrel=0"
	[ -z "$pkgdesc" ] && die "Missing pkgdesc in APKBUILD"
	[ -z "$url" ] && die "Missing url in APKBUILD"
	[ -z "$license" ] && die "Missing license in APKBULID"

58 59 60 61 62 63 64 65
	if [ "$(echo $source | wc -l)" -ne "$(echo $md5sums | wc -l)" ]; then
		die "Number of md5sums does not correspond to number of sources"
	fi

	if [ "$(echo $subpackages | wc -w)" -ne "$(echo $splitfuncs | wc -w)" ]; then
		die "Number of subpackages does not correspond to number of splitfuncs"
	fi

66 67 68 69 70 71 72
	# common spelling errors
	[ -n "$depend" ] && die "APKBUILD contains 'depend'. It should be depends"
	[ -n "$makedepend" ] && die "APKBUILD contains 'makedepend'. It should be makedepends"

	return 0
}

Natanael Copa's avatar
Natanael Copa committed
73
# check if we have needed packages to build this thing
74
makedepcheck() {
Natanael Copa's avatar
Natanael Copa committed
75 76 77 78 79 80 81 82 83 84
	local i
	local missing=
	for i in $makedepends; do
		apk_info -e $i || missing="$missing $i"
	done
	[ -z "$missing" ] && return 0
	warning "Missing makedepends: $missing"
	return 1
}

85
md5check() {
86 87 88
	if [ -z "$source" ]; then
		return 0
	fi
89 90 91
	if [ -z "$md5sums" ]; then
		die "Use 'abuild checksum >>$APKBUILD' to generate a checksum"
	fi
92 93 94 95

	if [ "$(echo $source | wc -l)" -ne "$(echo $md5sums | wc -l)" ]; then
		die "Number of md5sums does not correspond to number of sources"
	fi
96
	cd "$srcdir" && echo "$md5sums" | md5sum -c 
Natanael Copa's avatar
Natanael Copa committed
97 98 99 100 101
}

uri_fetch() {
	local uri="$1"
	local d="${s##*/}"	# $(basename $s)
102 103 104 105
	local opts
	[ -n "$quiet" ] && opts="-q"
	[ -f "$SRCDEST/$d" ] && return 0

Natanael Copa's avatar
Natanael Copa committed
106
	mkdir -p "$SRCDEST"
107 108 109
	if [ -f "$SRCDEST/$d.part" ]; then
		msg "Partial download found. Trying to resume"
		opts="$opts -c"
Natanael Copa's avatar
Natanael Copa committed
110
	fi
111 112
	wget $opts -O "$SRCDEST/$d.part" "$uri" \
		&& mv "$SRCDEST/$d.part" "$SRCDEST/$d"
Natanael Copa's avatar
Natanael Copa committed
113 114 115 116 117 118 119 120 121 122 123 124 125 126 127 128 129 130 131 132 133 134
}

fetch() {
	local s
	mkdir -p "$srcdir"
	for s in $source; do 
		case "$s" in
			http://*|ftp://*)
				uri_fetch "$s" || return 1
				;;
		esac
		ln -sf "$SRCDEST/${s##*/}" "$srcdir"/
	done
}

# unpack the sources
unpack() {
	local u
	mkdir -p "$srcdir"
	for u in $source; do
		local s="$SRCDEST/${u##*/}"	# $(basename $s)
		case "$s" in
Natanael Copa's avatar
Natanael Copa committed
135
			*.tar.gz|*.tgz)
Natanael Copa's avatar
Natanael Copa committed
136 137 138 139 140 141 142 143 144 145 146 147
				tar -C "$srcdir" -zxf "$s" || return 1;;
			*.tar.bz2)
				tar -C "$srcdir" -jxf "$s" || return 1;;
		esac
	done
}

# cleanup source and package dir
clean() {
	rm -rf "$srcdir"
	rm -rf "$pkgdir"
	local i
148
	for i in $splitfuncs; do
149
		rm -rf "$pkgdir-$i"
Natanael Copa's avatar
Natanael Copa committed
150 151 152 153 154 155 156 157 158
	done
}

# cleanup fetched sources
cleancache() {
	local s
	for s in $source; do
		case "$s" in
			http:/*|ftp:/*)
Natanael Copa's avatar
Natanael Copa committed
159
				rm -f "$SRCDEST/$(basename $s)";;
Natanael Copa's avatar
Natanael Copa committed
160 161 162 163 164 165
		esac
	done
}

cleanpkg() {
	local i
166 167 168
	for i in $pkgname $subpackages; do
		local p="$i-$pkgver-$pkgrel"
		rm -f "$PKGDEST/$p.apk" "$PKGDEST/$p.src.tar.gz"
Natanael Copa's avatar
Natanael Copa committed
169 170 171 172 173
	done
}

runpart() {
	local part=$1
Natanael Copa's avatar
Natanael Copa committed
174
	msg "$part"
Natanael Copa's avatar
Natanael Copa committed
175 176 177 178 179 180 181 182 183
	$part || die "$part failed"
}

# override those in your build script
build() {
	die "No build() function found in $APKBUILD"
}

subpkg() {
184 185 186
	if [ -z "$splitfuncs" ] && [ -z "$subpackages" ]; then
		return 0
	fi
Natanael Copa's avatar
Natanael Copa committed
187 188
	local i
	cd "$startdir"
189 190 191 192 193
	set $splitfuncs
	for i in $subpackages; do
		subpkgdir="$startdir/pkg-$1" subpkgname="$i" $0 $1 package \
			|| return 1
		shift
Natanael Copa's avatar
Natanael Copa committed
194 195 196 197
	done
}

package_apk() {
198 199
	local name=${subpkgname:-$pkgname}
	[ -z "${name##* *}" ] && die "package name contains spaces"
200
	local dir=${subpkgdir:-$pkgdir}
201
	local pkg="$name-$pkgver-$pkgrel.apk"
Natanael Copa's avatar
Natanael Copa committed
202 203 204 205 206 207 208 209 210 211 212 213 214
	
	[ ! -d "$dir" ] && die "Missing $dir"
	cd "$dir"
	msg "Creating $pkg"
	local builddate=$(date -u "+%s")
	local size=$(du -sk | awk '{print $1 * 1024}')

	echo "# Generated by $(basename $0) $myver" >.PKGINFO
	if [ -n "$FAKEROOTKEY" ]; then
		echo "# using $(fakeroot -v)" >> .PKGINFO
	fi
	echo "# $(date -u)" >> .PKGINFO
	cat >> .PKGINFO <<EOF
215
pkgname = $name
216
pkgver = $pkgver-$pkgrel
Natanael Copa's avatar
Natanael Copa committed
217 218 219 220 221 222
pkgdesc = $pkgdesc
url = $url
builddate = $builddate
packager = ${PACKAGER:-"Unknown"}
size = $size
EOF
Natanael Copa's avatar
Natanael Copa committed
223
	local i
Natanael Copa's avatar
Natanael Copa committed
224 225 226 227 228 229 230 231 232 233 234 235 236 237 238 239 240 241 242 243 244

	for i in $license; do
		echo "license = $i" >>.PKGINFO
	done
	for i in $replaces; do
		echo "replaces = $i" >>.PKGINFO
	done
	for i in $depends; do
		echo "depend = $i" >>.PKGINFO
	done
	for i in $conflicts; do
		echo "conflict = $i" >>.PKGINFO
	done
	for i in $provides; do
		echo "provides = $i" >>.PKGINFO
	done
	for i in $backup; do
		echo "backup = $i" >>.PKGINFO
	done

	local metafiles=".PKGINFO"
Natanael Copa's avatar
Natanael Copa committed
245 246 247
	if [ -n "$install" ]; then
		cp "$srcdir/$install" "$dir/.INSTALL" || return 1
		chmod +x "$dir/.INSTALL"
Natanael Copa's avatar
Natanael Copa committed
248
		metafiles="$metafiles .INSTALL"
Natanael Copa's avatar
Natanael Copa committed
249
	fi
Natanael Copa's avatar
Natanael Copa committed
250 251 252 253 254 255 256 257

#	for i in pre-install post-install pre-deinstall post-deinstall; do
#		[ -f ../$i ] && cp ../$i "$db"/
#	done
	
	set *
	[ "$1" = '*' ] && set --
	( cd "$dir" && tar -zcf "$PKGDEST/$pkg" $metafiles $@ )
Natanael Copa's avatar
Natanael Copa committed
258 259 260 261 262 263
}

package() {
	package_apk
}

264
# predefined splitfunc doc
Natanael Copa's avatar
Natanael Copa committed
265 266 267 268
doc() {
	depends=""
	local i
	for i in doc man info html sgml; do
269 270 271
		if [ -d "$pkgdir/usr/share/$i" ]; then
			mkdir -p "$subpkgdir/usr/share"
			mv "$pkgdir/usr/share/$i" "$subpkgdir/usr/share/"
Natanael Copa's avatar
Natanael Copa committed
272 273
		fi
	done
274 275 276 277

	# remove if empty, ignore error (not empty)
	rmdir "$pkgdir/usr/share" "$pkgdir/usr" 2>/dev/null

278
	[ -d "$subpkgdir/usr/share/man" ] && depends="man"
Natanael Copa's avatar
Natanael Copa committed
279 280 281
	return 0
}

282
# predefined splitfunc mod
Natanael Copa's avatar
Natanael Copa committed
283 284 285
mod() {
	depends="$kernel"
	for i in firmware modules; do
286 287 288
		if [ -d "$pkgdir/lib/$i" ]; then
			rm -rf "$subpkgdir/lib"
			mkdir -p "$subpkgdir/lib"
289
			mv "$pkgdir/lib/$i" "$subpkgdir/lib"
Natanael Copa's avatar
Natanael Copa committed
290 291 292 293
		fi
	done
}

294
# predefined splitfunc dev
Natanael Copa's avatar
Natanael Copa committed
295
dev() {
296 297
	depends="$pkgname"
	for i in $(cd "$pkgdir" && find usr/lib -name '*.a' -o \
Natanael Copa's avatar
Natanael Copa committed
298 299
			-name '*.la' -o -name '*.o' 2>/dev/null) \
			usr/include usr/lib/pkgconfig usr/share/aclocal; do
300 301
		if [ -e "$pkgdir/$i" ] || [ -L "$pkgdir/$i" ]; then
			d="$subpkgdir/${i%/*}"	# dirname $i
Natanael Copa's avatar
Natanael Copa committed
302
			mkdir -p "$d"
303
			mv "$pkgdir/$i" "$d"
Natanael Copa's avatar
Natanael Copa committed
304 305 306 307 308 309
		fi
	done
}

# build and package in fakeroot
rootpkg() {
Natanael Copa's avatar
Natanael Copa committed
310
	cd "$startdir"
Natanael Copa's avatar
Natanael Copa committed
311 312 313 314
	fakeroot $0 build subpkg package
}

srcpkg() {
315
	local p="$pkgname-$pkgver-$pkgrel"
Natanael Copa's avatar
Natanael Copa committed
316
	local prefix="${startdir##*/}"
Natanael Copa's avatar
Natanael Copa committed
317 318 319 320 321
	local i files="$prefix/APKBUILD"
	for i in $source; do
		files="$files $prefix/${i##*/}"
	done
	mkdir -p "$PKGDEST"
322
	(cd .. && tar -zcf "$PKGDEST/$p.src.tar.gz" $files) 
Natanael Copa's avatar
Natanael Copa committed
323 324
}

325 326
# check if package is up to date
up2date() {
327
	local pkg="$PKGDEST/$pkgname-$pkgver-$pkgrel.apk"
328
	local i s
Natanael Copa's avatar
Natanael Copa committed
329
	cd "$startdir"
330 331 332 333 334 335 336 337 338 339
	[ -f "$pkg" ] || return 1
	for i in $source APKBUILD; do
		local s="$SRCDEST/${i##*/}"	# $(basename $i)
		if [ "$s" -nt "$pkg" ]; then
			return 1
		fi
	done
	return 0
}

Natanael Copa's avatar
Natanael Copa committed
340 341 342 343 344 345 346 347 348
usage() {
	echo "$(basename $0) $myver"
	echo "usage: $0 [options] [cmd] ..."
	echo "Options:"
	echo " -h  Show this help"
	echo " -f  Force specified cmd, even if they are already done"
	echo " -q  Quiet"
	echo ""
	echo "Commands:"
349 350 351 352 353 354 355 356 357 358 359 360 361
	echo "  checksum    Generate checksum to be included in $APKBUILD"
	echo "  fetch       Fetch sources to \$SRCDEST and verify checksums"
	echo "  sanitycheck Basic sanity check of APKBUILD"
	echo "  md5check    Check md5sums"
	echo "  unpack      Unpack sources to \$srcdir"
	echo "  build       Compile and install package into \$pkgdir"
	echo "  package     Create package in \$PKGDEST"
	echo "  rootpkg     Run '$0 build package' as fakeroot"
	echo "  clean       Remove temp build and install dirs"
	echo "  cleanpkg    Remove already built binary and source package"
	echo "  cleancache  Remove downloaded files from \$SRCDEST"
	echo "  srcpkg      Make a source package"
	echo "  up2date     Compare target and sources dates"
Natanael Copa's avatar
Natanael Copa committed
362 363 364 365 366 367 368 369 370
	echo ""
	exit 0
}

checksum() {
	local s files
	for s in $source; do
		files="$files ${s##*/}"
	done
371 372
	md5sums="$(cd "$SRCDEST" && md5sum $files)" || die "md5sum failed"
	echo "md5sums=\"$md5sums\""
Natanael Copa's avatar
Natanael Copa committed
373 374 375 376 377 378 379 380 381 382 383 384 385 386 387 388 389
}

APKBUILD="${APKBUILD:-./APKBUILD}"

while getopts "hfq" opt; do
	case $opt in
		'h') usage;;
		'f') force=1;;
		'q') quiet=1;;
	esac
done
shift $(( $OPTIND - 1 ))

# source the buildfile
[ -f "$APKBUILD" ] || die "Could not find $APKBUILD (PWD=$PWD)"
. "$APKBUILD"

390 391 392 393 394
# If we are handling a sub package then reset splitfuncs and subpackages
if [ -n "$subpkgname" ]; then
	splitfuncs=
	subpackages=
fi
Natanael Copa's avatar
Natanael Copa committed
395 396 397 398 399 400 401

trap 'die "Aborted by user"' INT

[ -n "$forceunpack" ] && rm -f "$srcdir"/.unpack


if [ -z "$1" ]; then
Natanael Copa's avatar
Natanael Copa committed
402
	if up2date && [ -z "$force" ]; then
Natanael Copa's avatar
Natanael Copa committed
403
		msg "Package is up to date"
404 405 406
	else
		set $default_cmds
	fi
Natanael Copa's avatar
Natanael Copa committed
407 408 409 410 411 412 413
fi

while [ $# -gt 0 ]; do
	runpart $1
	shift
done